/*
 ============================================================================
 Name		 : UpdateTimer.cpp
 Copyright   : Symbian Academy, 2007
 Description : Regularly calls the update method of the game engine.
 ============================================================================
 */

#ifndef UPDATETIMER_H_
#define UPDATETIMER_H_

#include <e32base.h>
#include <e32std.h>
#include "Engine.h"

class CEngine;

// Edit 1: Derive the class from CActive
class CUpdateTimer
	{
public:
	// Construct / destruct
	static CUpdateTimer* NewLC(CEngine* aEngine);
	static CUpdateTimer* NewL(CEngine* aEngine);
	~CUpdateTimer();

	// Request
	void StartProcess(TTimeIntervalMicroSeconds32 aDelay);

	void IncreaseSpeed(TTimeIntervalMicroSeconds32 aSpeed);

private:
	// Construct / destruct
	CUpdateTimer(CEngine* aEngine);
	void ConstructL();

	// Edit 2: Define the RunL()-function from the CActive base class
	
	
	// Edit 3: Define the DoCancel()-function from the CActive base class
	

private:
	// Edit 4: Create an instance variable called iTimer of type RTimer.
	//         This is the communication class to the asynchronous service 
	//         provider.
	
	
	TTimeIntervalMicroSeconds32 iDelay;
	CEngine* iEngine;
	};

#endif /*UPDATETIMER_H_*/
